#ifdef SCR96
Cpy2Home:
 push af
IonFastCopy:
 di
 ld a,$80 ; 7
 out (16),a ; 11
 ld hl,_plotSScreen-12-(-767) ; 10
 ld a,32 ; 7
 ld c,a ; 4
 inc hl ; 6 waste
 dec hl ; 6 waste
fastCopyAgain2:
 ld b,64 ; 7
 inc c ; 4
 ld de,-767
 out (16),a ; 11
 add hl,de ; 11
 ld de,10 ; 10
fastCopyLoop2:
 add hl,de ; 11
 inc hl ; 6 waste
 inc hl ; 6 waste
 inc de ; 6
 ld a,(hl) ; 7
 out (17),a ; 11
 dec de ; 6
 djnz fastCopyLoop2 ; 13/8
 ld a,c ; 4
 cp 44 ; 7
 jr nz,fastCopyAgain2 ; 10/1
 pop af
 ret ; 10
#endif

Collision_DetectionG:
 ld a,(Vegetaxy)
 ld b,a
 ld a,(FireGxy)
 sub b
 cp 23
 ret nc
 ld a,(Vegetaxy+1)
 ld b,a
 ld a,(FireGxy+1)
 sub b
 sub 13
 cp 3
 ret nc
 ld a,(VegetaP)
 ld d,61
 ld e,a
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 inc e
 inc d
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 inc d
 dec e
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 ld hl,VegetaP
 dec (hl)
 ld a,(hl)
 or a
 ret nz
 pop bc
 pop bc
 pop bc
 jp ContinuePrg

Collision_Detection:
 ld a,(Kakarotxy)
 ld b,a
 ld a,(Firexy)
 sub b
 cp 23
 ret nc
 ld a,(Kakarotxy+1)
 ld b, a
 ld a,(Firexy+1)
 add a,16
 sub b
 cp 3
 ret nc
 ld a,(KakarotP)
 ld d,61
 ld e,a
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 dec e
 inc d
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 inc d
 inc e
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 ld hl,KakarotP
 inc (hl)
 ld a,(hl)
 cp 96
 ret nz
 pop bc
 pop bc
 pop bc
 jp Winner
 
; input: e=y coordinate, a=x coordinate
; output: a holds data for pixel
; hl->byte where pixel is on the gbuf
FindPixel:
 ld a,e
 ld e,d
 ld d,0
 ld h,d
 ld l,e
 add hl,de
 add hl,de
 add hl,hl
 add hl,hl
 ld de,_plotSScreen
 add hl,de
 ld b,0
 ld c,a
 and 7
 srl c
 srl c
 srl c
 add hl,bc
 ld b,a
 inc b
 ld a,1
getPixelLoop:
 rrca
 djnz getPixelLoop
 ret

PutIt:
 ld a,b
 ld l,c
 ld bc,$0502
 jr largeSprite
 
;Input: ix->sprite
; a=x, l=y, b=height (in pixels)
; c=width     (in bytes, e.g. 2 would be 16)
;Output: nothing
; All registers are destroyed except bc', de', hl'
PutSprite:
 ld a,b
 ld l,c
 ld bc,$1C02
largeSprite:
 di
 ex af,af'
 ld a,c
 push af
 ex af,af'
 ld e,l
 ld h,0
 ld d,h
 add hl,de
 add hl,de
 add hl,hl
 add hl,hl
 ld e,a
 and 7
 ld c,a
 srl e
 srl e
 srl e
 add hl,de
 ld de,_plotSScreen
 add hl,de
largeSpriteLoop1:
 push hl
largeSpriteLoop2:
 ld d,(ix)
 ld e,0
 ld a,c
 or a
 jr z,largeSpriteSkip1
largeSpriteLoop3:
 srl d
 rr e
 dec a
 jr nz,largeSpriteLoop3
largeSpriteSkip1:
 ld a,(hl)
 xor d
 ld (hl),a
 inc hl
 ld a,(hl)
 xor e
 ld (hl),a
 inc ix
 ex af,af'
 dec a
 push af
 ex af,af'
 pop af
 jr nz,largeSpriteLoop2
 pop hl
 pop af
 push af
 ex af,af'
 ld de,12
 add hl,de
 djnz largeSpriteLoop1
 pop af
 ret
 